#!BPY

"""
Name: 'FreeHuman v2008.1.9'
Blender: 245
Group: 'Wizards'
Tooltip: 'Creates metaballs from armature'
"""

# ------------------------------------
# Informacia dlya polzovateley skripta
# ====================================

__author__ = ["Unknown Author"]
__url__ = ("http://www.igrodel.ru")
__version__ = "2008.1.8"
__bpydoc__ = """\

Creates metaballs from armature
based on Blender Python API Reference Built Thu May 10 20:32:02 EST 2007

"""

from Blender import *

def main():

	scn= Scene.GetCurrent()
	ob_arm= scn.objects.active
	if not ob_arm or ob_arm.type!='Armature':
		Draw.PupMenu('No Armature Selected')
		return
	arm= ob_arm.data

	res= Draw.PupFloatInput('res:', 0.2, 0.05, 2.0)
	fat= Draw.PupFloatInput('fat:', 5.0, 1.0, 10.0)

	if not res:
		return

	if not fat:
		return


# Make a metaball

	mb= Metaball.New('zzz')
	mb.wiresize= res

# Link to the Scene

#	sce = Blender.Scene.GetCurrent()
#	sce.objects.new(mb)

#	ob_mb = scn.objects.new(ob_mb)
#	ob_arm.sel= 0
#	ob_mb.setMatrix(ob_arm.matrixWorld)

	meta_type= 0 # all elemts are ball type
	meta_stiffness= 2.0 # Volume

	for bone in arm.bones.values():
		print bone

		# Find out how many metaballs to add based on bone length, 4 min
		length= bone.length
		if length < res:
			mballs= 4
		else:
			mballs= int(length/res)
			if mballs < 4:
				mballs = 4

		print 'metaball count', mballs

		# get the bone properties
		head_rad= bone.headRadius
		tail_rad= bone.tailRadius

		head_loc= bone.head['ARMATURESPACE']
		tail_loc= bone.tail['ARMATURESPACE']

		for i in range(mballs):
			f= float(i)

			w1= f/mballs # weighting of this position on the bone for rad and loc
			w2= 1-w1

			loc= head_loc*w1 + tail_loc*w2
			rad= (head_rad*w1 + tail_rad*w2) * fat

			# Add the metaball
			ml= mb.elements.add()
			ml.co= loc
			ml.radius= rad
			ml.stiffness= meta_stiffness
			print 'add'

	ob_mb = scn.objects.new(mb)
	ob_arm.sel= 0
	ob_mb.setMatrix(ob_arm.matrixWorld)


#	Blender.Draw.PupMenu('UV Copy Finished')

main()