// -------------------------------------------------------------
// 3d code by Georgy Moshkin (Delphi)
// licence: public domain
// -------------------------------------------------------------
unit mymodels;

interface

uses mymeshes,
     myskeletons,
     mytextures,
     mynftloader;

type TModel = record
               Meshes:TMeshes;
               skAnimations:TSkeletonAnimations;
              end;

type TModels = array of TModel;

function loadModel(filename:string;var models:TModels;var textures:TTextures):integer;

implementation

function loadModel(filename:string;var models:TModels;var textures:TTextures):integer;
var i,k:integer;
begin
k:=length(models);
setlength(models,k+1);
loadnft(filename,
        models[k].Meshes,
        models[k].skAnimations,
        textures);

for i:=0 to length(models[k].Meshes)-1 do
 with models[k] do
  BuildSkeleton(Meshes[i].restverts,
                Meshes[i].transverts,
                Meshes[i].vertsParents,
                skAnimations.reference,
                skAnimations.skeleton);

result:=k;        
end;

end.
